<?php

/***************************************************************************************
 *											*
 *   	Copyright 2006 by Davide Simoncelli                                      	*
 *   	Email: netcelli_gentoo at users dot sourceforge dot net                      	*
 *                                                                         		*
 *   	This program is free software; you can redistribute it and/or			*
 *	modify it under the terms of the GNU General Public License			*
 *	as published by the Free Software Foundation; either version 2			*
 *	of the License, or (at your option) any later version.				*
 *											*
 *	This program is distributed in the hope that it will be useful,			*
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of			*
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			*
 *	GNU General Public License for more details.					*
 *											*
 *	You should have received a copy of the GNU General Public License		*
 *	along with this program; if not, write to the Free Software			*
 *	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.	*	
 *											*
 ****************************************************************************************/

/**
 *	@name Language
 *	@static
 * 	@package VHCP
*/


class Language
{
	private $lang = array();
	
	private $languages = array(
		'en'=>'English',
		'hu'=>'Hungarian',
		'it'=>'Italian',
		'es'=>'Spanish',
		'ro'=>'Romanian',
		'ru'=>'Russian',
		'cs'=>'Serbian',
		'ba'=>'Bosnian',
		'se'=>'Swedish',
		'lt'=>'Lithuanian',
		'cz'=>'Czech',
		'no'=>'Norwegian',
		'fr'=>'French',
		'pl'=>'Polish'
		);
	
	/**
    * Costructor
    * @access public
   	*/
		
	public function __construct()
	{
		if(isset($_GET['lang']))
		{
			$l = $_GET['lang'];
			$_SESSION['lang'] = $l;
		}
		elseif(isset($_SESSION['lang']))
		{
			$l = $_SESSION['lang'];
		}
		else
		{
			$l = 'en';
		}
		$lang = $l;
		$file = "./lang/$lang.php";
		$handle = fopen($file,"r");
		$content = fread($handle,filesize($file));
		$content = explode("\n",$content);
		unset($content[0]);
		while(array_search('',$content)>0)
		{
			$key = array_search('',$content);
			unset($content[$key]);
		}
		foreach($content as $key=>$value)
		{
			list($k,$v) = explode(':',$value,2);
			$this->lang[$k] = $v;
		}
		// print_r($this->lang);
	}
	
	/**
    * Return the translated word or sentence
    * @param string $key the word to be translated
   	* @access public
   	* @return string
   	*/
	
	public function getWord($key)
	{
		if(array_key_exists($key,$this->lang))
		{
			return $this->lang[$key];
		}
		else
		{
			return "\{$key}";
		}
	}
	
	/**
    * Echo all languages available with flags
    * @param $separator
    * @access public
   	*/
	
	public function printLanguage($separator="|")	
	{
		foreach($this->languages as $k=>$v)
		{
			echo "  <tr>\n";
			echo "    <td style=\"width:25px;\">";
			echo "<img src=\"img/flags/$k.gif\" alt=\"$k\" title=\"$v\" />";
			echo "    </td>\n";
			echo "    <td>";
			echo "<a href=\"?page=start&amp;lang=$k\">$v</a> $separator";
			echo "    </td>\n";
			echo "  </tr>\n";
		
		}
	}
}
?>