<?php

/***************************************************************************************
 *											*
 *   	Copyright 2006 by Davide Simoncelli                                      	*
 *   	Email: netcelli_gentoo at users dot sourceforge dot net                      	*
 *                                                                         		*
 *   	This program is free software; you can redistribute it and/or			*
 *	modify it under the terms of the GNU General Public License			*
 *	as published by the Free Software Foundation; either version 2			*
 *	of the License, or (at your option) any later version.				*
 *											*
 *	This program is distributed in the hope that it will be useful,			*
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of			*
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			*
 *	GNU General Public License for more details.					*
 *											*
 *	You should have received a copy of the GNU General Public License		*
 *	along with this program; if not, write to the Free Software			*
 *	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.	*	
 *											*
 ****************************************************************************************/

/**
 *	@name Verlidb
 * 	@static 
 * 	@since VHCP 1.7
 * 	@package VHCP
*/


class Verlidb extends MySQL
{
	/**
     * Update Verlihub config
     * @param string $var the variable to edit
     * @param string $val the value to store
     * @return void
     * @access public
     */
	
	public function setConfig($var,$val)
	{
		if($user->checkClass(5))
		{
			MySQL::runQuery("UPDATE `SetupList` SET `val` = '$val' WHERE `var` = '$var' LIMIT 1");
		}
	}
	
	/**
     * Get a Verlihub config value
     * @param string $var the variable to edit
     * @param string $table_name the table where to take a value
     * @param string $bol Show an error message
     * @access public
     * @return string/bool
     */
	
	public function getConfig($var,$table_name='SetupList',$bol=false)
	{
		if ($table_name == 'SetupList')	$query = MySQL::runQuery("SELECT * FROM `SetupList` WHERE `var` = '$var' LIMIT 1",true);
		elseif ($table_name == 'ezechiele') $query = MySQL::runQuery("SELECT valore AS `val` FROM  `ezesettings` WHERE `name` = '$var' LIMIT 1",true);
		if(mysql_num_rows($query)>0)
		{
			$setup = mysql_fetch_assoc($query);
			return $setup['val'];
		}
		elseif($bol && mysql_num_rows($query)<1)
		{
			return false;
		}
		else
		{
			return "<i>Config `{$var}` doesn't exist</i>";
		}
	}
	
	/**
     * Add new user to reglist table
     * @param string $nick the nick to add
     * @param sting $class the user's class
     * @access public
     * @return bool
     */
	
	public function addUser($nick,$class)
	{
		$regdate = mktime();
		$reg_op = USER_NICK;
		if (MySQL::runQuery("INSERT INTO `reglist` (`nick`,`class`,`reg_op`,`reg_date`) values('$nick','$class','$reg_op','$regdate')")) return true;
		else return false;
	}
	
	/**
     * Update the user's password and return a message or user class
     * @param string $nick the user nick
     * @param sting $passwd1 the password
     * @param string $passwd2 the password to check
     * @param user $user the password to check
     * @access public
     * @return string/bool
     */
	
	public function changePassword($nick, $passwd1, $passwd2,$user)
	{
		if (empty($passwd1) XOR empty($passwd2)) return 'edituser&message=passchange_empty&type=error';
		elseif (empty($passwd1) AND empty($passwd2)) return 'edituser&message=passchange_empty2&type=error';
		else
		{
			$info_user = $user->getUserInfo($nick);
			if($encrypt = Verlidb::getConfig("default_password_encryption",true))
			{
				if($user->checkClass($info_user['class'],false))
				{
					if($passwd1==$passwd2)
					{
						if($encrypt==1)
						{
							$newpass = crypt($passwd1,0);
							MySQL::runQuery("UPDATE `reglist` SET login_pwd = '$newpass' WHERE `nick` = '$nick' LIMIT 1");
						}
						elseif($encrypt==2)
						{
							$newpass = md5($passwd1);
							MySQL::runQuery("UPDATE `reglist` SET login_pwd = '$newpass' WHERE `nick` = '$nick' LIMIT 1");
						}
						else
						{
							$newpass = $_POST['pass1'];
							MySQL::runQuery("UPDATE `reglist` SET login_pwd = '$newpass' WHERE `nick` = '$nick' LIMIT 1");
						}
						return "reglist&message=passwd_changed&type=good&nick=$nick";
					}
					else
					{
						return "reglist&message=passwd_match&type=error";
					}
				}
				else
				{
					return "reglist&message=passwd_error&type=good&nick=$nick";
				}
			}
			else
			{
				$newpass = crypt($passwd1,0);
				MySQL::runQuery("UPDATE `reglist` SET login_pwd = '$newpass' WHERE `nick` = '$nick' LIMIT 1");
				return "reglist&message=passwd_changed&type=good&nick=$nick";
			}
		}
	}
	
	/**
    * Return the class of the specify user
    * @param string $nick nick of the user
    * @return int
    * @access public
   	*/
	
	
	public function getClass($nick)
	{
		$class = Verlidb::getUserInfo($nick,"`class`");
		return intval($class['class']);
	}
	
	/**
    * Update infomarmation about a specify user
    * @param string $nick nick of the user
    * @param string $setting the field to update
    * @param string $value the value of the field
    * @param User $user the User Object
    * @return void
    * @access public
   	*/
	
	public function updateUser($nick,$setting,$value,$user)
	{
		if($user->checkClass(Verlidb::getClass($nick),false))
		{
			MySQL::runQuery("UPDATE `reglist` SET `$setting` = '$value' WHERE `nick` = '$nick' LIMIT 1");
		}
	}
	
	/**
    * Return a config value of VHCP Setting
    * @param string $var the variable
    * @return string
    * @access public
   	*/
	
	public function VHCP_config($var)
	{
		if ($query = MySQL::runQuery("SELECT `val` FROM vhcp where `var`='$var'",true))
		{
			$r = mysql_fetch_assoc($query);
			return $r['val'];
		}
		else
		{
			MySQL::runQuery("CREATE TABLE IF NOT EXISTS `vhcp` (`var` varchar(20) NOT NULL,  `val` text NOT NULL,PRIMARY KEY  (`var`)) ENGINE=MyISAM");
			MySQL::runQuery("INSERT INTO `vhcp` (`var`, `val`) VALUES ('upload_lua', '0'),('upload_trigger', '0'),('verli_path', '/etc/verlihub'), ('backup', '0'), ('access', 'all'), ('min_class_manager', '10')");
			return false;
		}
	}
	
	/**
    * Return an array with user's info
    * @param string $nick nick of the user
    * @param string $fields which info to get
    * @return array/bool
    * @access public
   	*/
	
	public function getUserInfo($nick, $fields="*")
	{
		$query = MySQL::runQuery("SELECT $fields FROM `reglist` WHERE `nick` = '$nick' LIMIT 1",true);
		if(mysql_num_rows($query)>0)
		{
			$result = mysql_fetch_assoc($query);
			return $result;
		}
		else
		{
			return false;
		}
	}
}
?>